diff -crB c:\mame0106s\mame0106s\src/drivers/seattle.c c:\mingw9\mame\src/drivers/seattle.c
*** c:\mame0106s\mame0106s\src/drivers/seattle.c	Tue Mar 28 10:37:32 2006
--- c:\mingw9\mame\src/drivers/seattle.c	Thu May 24 20:04:32 2012
***************
*** 460,465 ****
--- 460,519 ----
  
  static UINT32 cmos_write_enabled;
  
+ static UINT16 last_port0;
+ static UINT8 shifter_state;
+ 
+ 
+ /*************************************
+  *
+  *  Input ports
+  *
+  *************************************/
+ 
+ static READ32_HANDLER( port0_r )
+ {
+ 	UINT16 val = readinputport(0);
+ 	UINT16 diff = val ^ last_port0;
+ 
+ if(options.geartype==2) //Sequential Shifter
+ {
+      if ((diff & 0x0100) && !(val & 0x0100)) //Gear UP handling
+      {
+            if (shifter_state==0) {shifter_state = 8;} //1st
+            else if (shifter_state==8) {shifter_state = 4;} //2nd
+            else if (shifter_state==4) {shifter_state = 2;} //3rd
+            else if (shifter_state==2) {shifter_state = 1;} //4th
+      }
+ 
+      if ((diff & 0x0200) && !(val & 0x0200)) ////Gear DOWN handling
+      {       
+            if (shifter_state==1) {shifter_state = 2;} //3rd
+            else if (shifter_state==2) {shifter_state = 4;} //2nd
+            else if (shifter_state==4) {shifter_state = 8;} //1st
+            //else if (shifter_state==8) {shifter_state = 0;} //neutral
+      }
+ 
+ }
+ 
+ else //geartype 0 or 1, original behaviour
+ {
+ 	/* make sure the shift controls are mutually exclusive */
+ 	if ((diff & 0x0800) && !(val & 0x0800))
+ 		shifter_state = (shifter_state == 1) ? 0 : 1;
+ 	if ((diff & 0x0400) && !(val & 0x0400))
+ 		shifter_state = (shifter_state == 2) ? 0 : 2;
+ 	if ((diff & 0x0200) && !(val & 0x0200))
+ 		shifter_state = (shifter_state == 4) ? 0 : 4;
+ 	if ((diff & 0x0100) && !(val & 0x0100))
+ 		shifter_state = (shifter_state == 8) ? 0 : 8;
+ }
+ 
+ 	last_port0 = val;
+ 	
+ 	val = (val | 0x3c00) ^ (shifter_state << 10);
+ 
+ 	return (val << 16) | val;
+ }
  
  
  /*************************************
***************
*** 1960,1979 ****
  	PORT_BIT( 0xe000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_MODIFY("P12")
! 	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2)	/* view 1 */
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(2)	/* view 2 */
! 	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(2)	/* view 3 */
! 	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(2)	/* music */
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(3)	/* track 1 */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(3)	/* track 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(3)	/* track 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(3)	/* track 4 */
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(1)	/* 1st gear */
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(1)	/* 2nd gear */
! 	PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(1)	/* 3rd gear */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(1)	/* 4th gear */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_VOLUME_DOWN )
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_VOLUME_UP )
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
--- 2014,2043 ----
  	PORT_BIT( 0xe000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_MODIFY("P12")
! 	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2) PORT_NAME("View 1")	/* view 1 */
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(2) PORT_NAME("View 2")	/* view 2 */
! 	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(2) PORT_NAME("View 3")	/* view 3 */
! 	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(2) PORT_NAME("Music")	/* music */
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(3) PORT_NAME("Track 1")	/* track 1 */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(3) PORT_NAME("Track 2")	/* track 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(3) PORT_NAME("Track 3")	/* track 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(3) PORT_NAME("Track 4")	/* track 4 */
! 
! if(options.geartype==2)
! 	{PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_BUTTON2) PORT_PLAYER(1) PORT_NAME("Gear Up")	/* Up*/
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(1) PORT_NAME("Gear Down")	/* Down*/
! 	PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_UNUSED ) 
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) ;}
! 
! else	
!     {PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(1) PORT_NAME("1st Gear")	/* 1st gear */
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(1) PORT_NAME("2nd Gear")	/* 2nd gear */
! 	PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(1) PORT_NAME("3rd Gear")	/* 3rd gear */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(1) PORT_NAME("4th Gear");}/* 4th gear */
! 	
! 	
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_VOLUME_DOWN ) PORT_NAME("Volume Up")
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_VOLUME_UP ) PORT_NAME("Volume Down")
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
***************
*** 1993,2008 ****
  	PORT_BIT( 0xff, 0x80, IPT_SPECIAL )
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_PLAYER(1)
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(100) PORT_PLAYER(2)
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(100) PORT_PLAYER(3)
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(5)
  INPUT_PORTS_END
  
  
--- 2057,2072 ----
  	PORT_BIT( 0xff, 0x80, IPT_SPECIAL )
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20)
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(100) 
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL3 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(100) 
  
  	PORT_START
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(5) PORT_NAME("Steering")
  INPUT_PORTS_END
  
  
diff -crB c:\mame0106s\mame0106s\src/drivers/segahang.c c:\mingw9\mame\src/drivers/segahang.c
*** c:\mame0106s\mame0106s\src/drivers/segahang.c	Sun Apr  9 22:49:08 2006
--- c:\mingw9\mame\src/drivers/segahang.c	Thu Feb 23 20:27:53 2012
***************
*** 630,642 ****
  	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_REVERSE
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20)
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40)
  INPUT_PORTS_END
  
  
--- 630,642 ----
  	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_REVERSE PORT_NAME("Steering")
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20) PORT_NAME("Accelerator")
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
***************
*** 729,744 ****
  	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
  
  	PORT_START_TAG("ADC0")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20)
  
  	PORT_START_TAG("ADC1")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40)
  
  	PORT_START_TAG("ADC2")	/* bank up/down */
! 	PORT_BIT( 0xff, 0x20, IPT_AD_STICK_Y ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4)
  
  	PORT_START_TAG("ADC3")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_AD_STICK_X ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_REVERSE
  INPUT_PORTS_END
  
  
--- 729,744 ----
  	PORT_DIPSETTING(    0x00, DEF_STR( On ) )
  
  	PORT_START_TAG("ADC0")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20) PORT_NAME("Accelerator")
  
  	PORT_START_TAG("ADC1")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40) PORT_NAME("Brake")
  
  	PORT_START_TAG("ADC2")	/* bank up/down */
! 	PORT_BIT( 0xff, 0x20, IPT_AD_STICK_Y ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_NAME("Wheelie")
  
  	PORT_START_TAG("ADC3")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_AD_STICK_X ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_REVERSE PORT_NAME("Steering")
  INPUT_PORTS_END
  
  
diff -crB c:\mame0106s\mame0106s\src/drivers/segaorun.c c:\mingw9\mame\src/drivers/segaorun.c
*** c:\mame0106s\mame0106s\src/drivers/segaorun.c	Tue Mar 28 10:37:32 2006
--- c:\mingw9\mame\src/drivers/segaorun.c	Thu Mar 22 20:43:53 2012
***************
*** 604,612 ****
  
  static INPUT_PORTS_START( outrun )
  	PORT_INCLUDE( outrun_generic )
- 
  	PORT_MODIFY("SERVICE")
! 	PORT_BIT( 0x10, IP_ACTIVE_HIGH, IPT_BUTTON1 ) PORT_TOGGLE PORT_CODE(KEYCODE_SPACE)
  
  	PORT_MODIFY("DSW")
  	PORT_DIPNAME( 0x03, 0x02, DEF_STR( Cabinet ) )
--- 604,617 ----
  
  static INPUT_PORTS_START( outrun )
  	PORT_INCLUDE( outrun_generic )
  	PORT_MODIFY("SERVICE")
! 	
! if(options.geartype==0) 
! {PORT_BIT( 0x10, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_NAME("Gear Shift");}
! else if (options.geartype==1) 
! {PORT_BIT( 0x10, IP_ACTIVE_HIGH, IPT_BUTTON1 ) PORT_NAME("Gear Shift");}
! else if (options.geartype==2) 
! {PORT_BIT( 0x10, IP_ACTIVE_HIGH, IPT_BUTTON1 ) PORT_TOGGLE PORT_NAME("Gear Shift");}
  
  	PORT_MODIFY("DSW")
  	PORT_DIPNAME( 0x03, 0x02, DEF_STR( Cabinet ) )
***************
*** 628,641 ****
  	PORT_DIPSETTING(    0x40, DEF_STR( Hard ) )
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
! 	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_PADDLE ) PORT_MINMAX(0x01,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4)
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20)
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40)
  INPUT_PORTS_END
  
  
--- 633,646 ----
  	PORT_DIPSETTING(    0x40, DEF_STR( Hard ) )
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
! 	PORT_START_TAG("ADC0")	/* Steering */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x20,0xe0) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_NAME("Steering")
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20) PORT_NAME("Gas Pedal")
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
***************
*** 661,673 ****
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_PADDLE ) PORT_MINMAX(0x01,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4)
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20)
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40)
  INPUT_PORTS_END
  
  
--- 666,678 ----
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x20,0xe0) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_NAME("Steering")
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20) PORT_NAME("Gas Pedal")
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
***************
*** 675,683 ****
  	PORT_INCLUDE( outrun_generic )
  
  	PORT_MODIFY("SERVICE")
! 	PORT_BIT( 0x10, IP_ACTIVE_HIGH, IPT_BUTTON1 ) PORT_TOGGLE PORT_CODE(KEYCODE_SPACE)
! 	PORT_BIT( 0x20, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_CODE(KEYCODE_LSHIFT)
! 
  	PORT_MODIFY("DSW")
  	PORT_DIPNAME( 0x03, 0x02, DEF_STR( Cabinet ) )
  	PORT_DIPSETTING(    0x02, "Cockpit Conversion" )
--- 680,693 ----
  	PORT_INCLUDE( outrun_generic )
  
  	PORT_MODIFY("SERVICE")
! if(options.geartype==0)
! {PORT_BIT( 0x10, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_CODE(KEYCODE_SPACE) PORT_NAME("Gear Shift");}
! else if(options.geartype==1)
! {PORT_BIT( 0x10, IP_ACTIVE_HIGH, IPT_BUTTON1 ) PORT_CODE(KEYCODE_SPACE) PORT_NAME("Gear Shift");}
! else if(options.geartype==2)
! {PORT_BIT( 0x10, IP_ACTIVE_HIGH, IPT_BUTTON1 ) PORT_TOGGLE PORT_CODE(KEYCODE_SPACE) PORT_NAME("Gear Shift");}
! 	
!     PORT_BIT( 0x20, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_NAME("Turbo")
  	PORT_MODIFY("DSW")
  	PORT_DIPNAME( 0x03, 0x02, DEF_STR( Cabinet ) )
  	PORT_DIPSETTING(    0x02, "Cockpit Conversion" )
***************
*** 702,714 ****
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_PADDLE ) PORT_MINMAX(0x01,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4)
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20)
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40)
  INPUT_PORTS_END
  
  
--- 712,724 ----
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x20,0xe0) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_NAME("Steering")
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20) PORT_NAME("Gas Pedal")
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
***************
*** 724,730 ****
  	PORT_SERVICE_NO_TOGGLE( 0x04, IP_ACTIVE_LOW )
  	PORT_BIT( 0x08, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x10, IP_ACTIVE_LOW, IPT_START1 )
! 	PORT_BIT( 0x20, IP_ACTIVE_LOW, IPT_BUTTON3 )	/* S.C. SW? */
  	PORT_BIT( 0x40, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x80, IP_ACTIVE_LOW, IPT_UNUSED )
  
--- 734,740 ----
  	PORT_SERVICE_NO_TOGGLE( 0x04, IP_ACTIVE_LOW )
  	PORT_BIT( 0x08, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x10, IP_ACTIVE_LOW, IPT_START1 )
! 	PORT_BIT( 0x20, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("Supercharger")	/* S.C. SW? */
  	PORT_BIT( 0x40, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x80, IP_ACTIVE_LOW, IPT_UNUSED )
  
***************
*** 744,756 ****
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x7f, IPT_PADDLE ) PORT_MINMAX(0x01,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_REVERSE
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20)
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40)
  INPUT_PORTS_END
  
  
--- 754,766 ----
  	PORT_DIPSETTING(    0x00, DEF_STR( Hardest ) )
  
  	PORT_START_TAG("ADC0")	/* steering */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x20,0xe0) PORT_SENSITIVITY(100) PORT_KEYDELTA(4) PORT_REVERSE PORT_NAME("Steering")
  
  	PORT_START_TAG("ADC1")	/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(20) PORT_NAME("Gas Pedal")
  
  	PORT_START_TAG("ADC2")	/* brake */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(40) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
***************
*** 1193,1198 ****
--- 1203,1261 ----
  	ROM_CONTINUE(        0x50000, 0x08000 )
  ROM_END
  
+ /* Outrun Enhanced Edition Hack(2011) 
+ this is a EPROM patched outrun created by C. White & D. Finck. I introduced this as a separate driver in order to let people play 
+ this modification as a clone, keeping also the original outrun in the game list.
+ To run this you need the patched epr10380b.133, epr10382b.118, epr10381b.132, epr10383b.117 ROMs
+ zipped alltoghether as "outrunee" in your "roms" folder  */
+ 
+ ROM_START( outrunee )
+ 	ROM_REGION( 0x60000, REGION_CPU1, 0 ) /* 68000 code */
+ 	ROM_LOAD16_BYTE( "epr10380b.133", 0x000000, 0x10000, CRC(1f6cadad) SHA1(31e870f307f44eb4f293b607123b623beee2bc3c) )
+ 	ROM_LOAD16_BYTE( "epr10382b.118", 0x000001, 0x10000, CRC(c4c3fa1a) SHA1(69236cf9f27691dee290c79db1fc9b5e73ea77d7) )
+ 	ROM_LOAD16_BYTE( "epr10381b.132", 0x020000, 0x10000, CRC(be8c412b) SHA1(bf3ff05bbf81bdd44567f3b9bb4919ed4a499624) )
+ 	ROM_LOAD16_BYTE( "epr10383b.117", 0x020001, 0x10000, CRC(10a2014a) SHA1(1970895145ad8b5735f66ed8c837d9d453ce9b23) )
+ 
+ 	ROM_REGION( 0x60000, REGION_CPU2, 0 ) /* second 68000 CPU */
+ 	ROM_LOAD16_BYTE( "epr10327a.76", 0x00000, 0x10000, CRC(e28a5baf) SHA1(f715bde96c73ed47035acf5a41630fdeb41bb2f9) )
+ 	ROM_LOAD16_BYTE( "epr10329a.58", 0x00001, 0x10000, CRC(da131c81) SHA1(57d5219bd0e2fd886217e37e8773fd76be9b40eb) )
+ 	ROM_LOAD16_BYTE( "epr10328a.75", 0x20000, 0x10000, CRC(d5ec5e5d) SHA1(a4e3cfca4d803e72bc4fcf91ab00e21bf3f8959f) )
+ 	ROM_LOAD16_BYTE( "epr10330a.57", 0x20001, 0x10000, CRC(ba9ec82a) SHA1(2136c9572e26b7ae6de402c0cd53174407cc6018) )
+ 
+ 	ROM_REGION( 0x30000, REGION_GFX1, ROMREGION_DISPOSE ) /* tiles */
+ 	ROM_LOAD( "opr10268.99",  0x00000, 0x08000, CRC(95344b04) SHA1(b3480714b11fc49b449660431f85d4ba92f799ba) )
+ 	ROM_LOAD( "opr10232.102", 0x08000, 0x08000, CRC(776ba1eb) SHA1(e3477961d19e694c97643066534a1f720e0c4327) )
+ 	ROM_LOAD( "opr10267.100", 0x10000, 0x08000, CRC(a85bb823) SHA1(a7e0143dee5a47e679fd5155e58e717813912692) )
+ 	ROM_LOAD( "opr10231.103", 0x18000, 0x08000, CRC(8908bcbf) SHA1(8e1237b640a6f26bdcbfd5e201dadb2687c4febb) )
+ 	ROM_LOAD( "opr10266.101", 0x20000, 0x08000, CRC(9f6f1a74) SHA1(09164e858ebeedcff4d389524ddf89e7c216dcae) )
+ 	ROM_LOAD( "opr10230.104", 0x28000, 0x08000, CRC(686f5e50) SHA1(03697b892f911177968aa40de6c5f464eb0258e7) )
+ 
+ 	ROM_REGION32_LE( 0x100000, REGION_GFX2, 0 ) /* sprites */
+ 	ROM_LOAD32_BYTE( "mpr10371.9",  0x00000, 0x20000, CRC(7cc86208) SHA1(21320f945f7c8e990c97c9b1232a0f4b6bd00f8f) )
+ 	ROM_LOAD32_BYTE( "mpr10373.10", 0x00001, 0x20000, CRC(b0d26ac9) SHA1(3a9ce8547cd43b7b04abddf9a9ab5634e0bbfaba) )
+ 	ROM_LOAD32_BYTE( "mpr10375.11", 0x00002, 0x20000, CRC(59b60bd7) SHA1(e5d8c67e020608edd24ba87b7687b2ac2483ee7f) )
+ 	ROM_LOAD32_BYTE( "mpr10377.12", 0x00003, 0x20000, CRC(17a1b04a) SHA1(9f7210cb4153ac9029a785dcd4b45f4513a4b008) )
+ 	ROM_LOAD32_BYTE( "mpr10372.13", 0x80000, 0x20000, CRC(b557078c) SHA1(a3746a2da077a8df4932348f650a061f413e8430) )
+ 	ROM_LOAD32_BYTE( "mpr10374.14", 0x80001, 0x20000, CRC(8051e517) SHA1(9c8509fbed170b4ac74c169da573393e54774f49) )
+ 	ROM_LOAD32_BYTE( "mpr10376.15", 0x80002, 0x20000, CRC(f3b8f318) SHA1(a5f2532613f33a64441e0f75443c10ba78dccc6e) )
+ 	ROM_LOAD32_BYTE( "mpr10378.16", 0x80003, 0x20000, CRC(a1062984) SHA1(4399030a155caf71f2dec7f75c4b65531ab53576) )
+ 
+ 	ROM_REGION( 0x8000, REGION_GFX3, 0 ) /* road gfx (2 identical roms, 1 for each road?) */
+ 	ROM_LOAD( "opr10185.11", 0x0000, 0x8000, CRC(22794426) SHA1(a554d4b68e71861a0d0da4d031b3b811b246f082) )
+ 	ROM_LOAD( "opr10186.47", 0x0000, 0x8000, CRC(22794426) SHA1(a554d4b68e71861a0d0da4d031b3b811b246f082) )
+ 
+ 	ROM_REGION( 0x10000, REGION_CPU3, 0 ) /* sound CPU */
+ 	ROM_LOAD( "epr10187.88",       0x00000, 0x8000, CRC(a10abaa9) SHA1(01c8a819587a66d2ee4d255656e36fa0904377b0) )
+ 
+ 	ROM_REGION( 0x60000, REGION_SOUND1, 0 ) /* sound PCM data */
+ 	ROM_LOAD( "opr10193.66",       0x00000, 0x8000, CRC(bcd10dde) SHA1(417ce1d7242884640c5b14f4db8ee57cde7d085d) )
+ 	ROM_LOAD( "opr10192.67",       0x10000, 0x8000, CRC(770f1270) SHA1(686bdf44d45c1d6002622f6658f037735382f3e0) )
+ 	ROM_LOAD( "opr10191.68",       0x20000, 0x8000, CRC(20a284ab) SHA1(7c9027416d4122791ba53782fe2230cf02b7d506) )
+ 	ROM_LOAD( "opr10190.69",       0x30000, 0x8000, CRC(7cab70e2) SHA1(a3c581d2b438630d0d4c39481dcfd85681c9f889) )
+ 	ROM_LOAD( "opr10189.70",       0x40000, 0x8000, CRC(01366b54) SHA1(f467a6b807694d5832a985f5381c170d24aaee4e) )
+ 	ROM_LOAD( "opr10188.71",       0x50000, 0x8000, CRC(bad30ad9) SHA1(f70dd3a6362c314adef313b064102f7a250401c8) )
+ ROM_END
+ 
  
  /**************************************************************************************************************************
   **************************************************************************************************************************
***************
*** 1703,1708 ****
--- 1766,1772 ----
  GAME( 1986, outrun2,  outrun,   outrun,  outrun,   outrun,   ROT0, "Sega",    "Out Run (set 2)", 0 )
  GAME( 1986, outrun1,  outrun,   outrun,  outrundx, outrun,   ROT0, "Sega",    "Out Run (set 1, Deluxe?)", 0 )
  GAME( 1986, outrunb,  outrun,   outrun,  outrun,   outrunb,  ROT0, "bootleg", "Out Run (bootleg)", 0 )
+ GAME( 1986, outrunee,  outrun,   outrun,  outrun,   outrun,  ROT0, "Sega",    "Out Run (Enhanced Edition, Hack)", 0 )
  GAME( 1987, shangon,  0,        shangon, shangon,  shangon,  ROT0, "Sega",    "Super Hang-On (set 4, 68000)", 0 )
  GAME( 1987, shangon3, shangon,  shangon, shangon,  shangon3, ROT0, "Sega",    "Super Hang-On (set 3, FD1089B 317-0034)", 0 )
  GAME( 1987, shangon2, shangon,  shangon, shangon,  shangon3, ROT0, "Sega",    "Super Hang-On (set 2, FD1089B 317-0034)", 0 )
